Subject: Re: bug#63648: 29.0.90; project.el: with switch-use-entire-map, switch-project errors on non-project commands

From: Juri Linkov <[email-masked]>
Date: Mon, 23 Oct 2023 20:34:58 +0300

>> Now can't type 'C-x p p C-x v d' completely because
>> 'C-x p p C-x v' opens vc-dir after typing 'v'.
>
> Huh. That actually works for me now, after I ran 'make' and restarted.
>
> But I thought you wanted this? 'C-x v d' ends with vc-dir, so if 'C-x
> p p C-x v' opens vc-dir, then isn't this what you expected?

Then can't use other vc commands like 'C-x p p C-x v L'

>> Maybe adding a new option 'project-switch-use-global-map' would help?
>
> Try the attached, it's another iteration on the latest patch
> (prefix-command-echo-keystrokes-functions doesn't seem to work reliably in
> this context). Try it together with
>
>   (setq project-switch-commands 'project-any-command)
>
> Also see the "Variation" in the comment (it allows for short bindings).

I tried it out but don't like that it requires an additional key 'o'.

I believe it should be possible to add a new option
'project-switch-use-global-map' (or a new value 'global' for existing
'project-switch-use-entire-map') that will combine 'project-prefix-map'
with global-map before reading a key sequence.